package com.simonstl.fragment;

import org.xml.sax.Attributes;
import java.io.IOException;
import java.util.*;

/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions  created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
*
* This class creates FragmentRule objects from a SAX event, or directly through a list of properties.
*
* @version 0.01 13 July 2001
* @author Simon St.Laurent
*/

public class FragmentRuleFactory {
    
    final static int MATCH=0;
    final static int SPLIT=1;
    final static int SERIES=2;

public static FragmentRule createRule (String uri, String local,
    String qName, Attributes atts)  {

    String pattern="";
    boolean repeat=false;
    boolean skipFirst=true;
    int type=0;
    FragmentRule newRule=null;

       
    if (uri.equals("http://simonstl.com/ns/fragments/")) {
//System.out.println(qName);
       if (local.equals("fragmentRule")) {
           pattern=atts.getValue("pattern");

           String repeater=atts.getValue("repeat");
           if (repeater!=null){
             if (repeater.equals("true")) {
               repeat=true;
             }
           }

           String _skipFirst=atts.getValue("skipFirst");
           if (_skipFirst!=null){
             if (_skipFirst.equals("false")) {
               skipFirst=false;
             }
           }
           
           String isSplit=atts.getValue("type");
           if (isSplit!=null){
             if (isSplit.equals("match")) {
               type=MATCH;
             } else if (isSplit.equals("split")) {
               type=SPLIT;
             } else if (isSplit.equals("series"))
               type=SERIES;
           }//end isSplit

      }//end fragmentRule
    }//end namespace rule

  newRule=createRule(pattern, repeat, skipFirst, type);

  return newRule;
}

public static FragmentRule createRule(String _pattern, boolean _repeat, boolean _skipFirst, int _type) {
   FragmentRule newRule=new FragmentRule(_pattern);
   newRule.setRepeat(_repeat);
   newRule.setSkipFirst(_skipFirst);
   newRule.setIsSplit(_type);
   newRule.complete();
   return newRule;
}

}