package com.simonstl.fragment;

import java.util.*;
import com.ibm.regex.RegularExpression;
import com.ibm.regex.Match;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* Regex4jMatch wraps the IBM  
* <a href="http://www.alphaworks.ibm.com/tech/regex4j?open&751aWHome" target="_new">com.ibm.regex.RegularExpression</a> class for
* matching. 
*
* Although the regex4j package is a superset of the Xerces regex classes, it is neither freely redistributable nor
* open source.
*
*<p>Version 0.01 is based on the similar {@link com.simonstl.fragment.XercesMatch XercesMatch}.</p>
*
* @version 0.01 11 July 2001
* @author Simon St.Laurent
*/


public class Regex4jMatch implements RegExInt {
private String pattern;
private RegularExpression regEx;
final int MATCH=0;

public Regex4jMatch () {

}

public Regex4jMatch (String _pattern) {
  pattern=_pattern;
  regEx=new RegularExpression(pattern);
}
public void setPattern(String _pattern) {
  pattern=_pattern;
  regEx=new RegularExpression(pattern);
}

/**
* This implementation uses the Apache Xerces regex engine to support the {@link com.simonstl.fragment.RegExInt RegExInt} interface.
*/

public ArrayList divide(String elementContent) {
   ArrayList matchResults=new ArrayList();
   Match match=new Match();
   if (regEx.matches(elementContent, match)) {
     int numberMatches=match.getNumberOfGroups();
//System.out.println(numberMatches +" matches");
//System.out.println(numberMatches-1+" matches, start="+start);
       for (int i=0; i<numberMatches; i++) {
         String value=match.getCapturedText(i);
         matchResults.add(value);
      }//end for
 } else {
System.out.println("False claim of match!!");
   } //end else for match
//System.out.println("Matched with Regex4j");

return matchResults;

}

public int getType(){
    return MATCH;
}

}