package com.simonstl.fragment;

import java.util.*;
import org.apache.regexp.*;


/*
The contents of this file are subject to the Mozilla Public License  Version 1.1 (the "License"); you may not use this file except in  compliance with the License. You may obtain a copy of the License at 
http://www.mozilla.org/MPL/ 
Software distributed under the License is distributed on an "AS IS"  basis, WITHOUT WARRANTY OF ANY KIND, either express or implied. See the  License for the specific language governing rights and limitations under  the License. 

The Original Code is available at  http://simonstl.com/projects/fragment/original. 

The Initial Developer of the Original Code is Simon St.Laurent. Portions created by Simon St.Laurent are Copyright (C) 2001. All Rights Reserved. 

Contributor(s): 
*/

/**
* RegexpSplit wraps the org.apache.regexp.RE for splitting.
*
* *<p>Version 0.01 cuts the SplitterImpl method out of {@link com.simonstl.fragment.RegexProcFactory RegexProcFactory}.</p>
*
* @version 0.01 11 July 2001
* @author Simon St.Laurent
*/


public class RegexpSplit implements RegExInt {
private String pattern;
private RE regEx;
final int SPLIT=1;

public RegexpSplit() {

}

public RegexpSplit (String _pattern) {
  pattern=_pattern;
  try {
     regEx=new RE(pattern);
      } catch (RESyntaxException e) {
System.out.println("bad pattern");
      }
}

public void setPattern(String _pattern) {
  pattern=_pattern;
  try {
     regEx=new RE(pattern);
      } catch (RESyntaxException e) {
System.out.println("bad pattern");
      }
}


/**
* This class uses the Apache regexp engine to implement the {@link com.simonstl.fragment.RegExInt RegExInt} interface.
*/

public ArrayList divide(String elementContent) {
   ArrayList splitResults=new ArrayList();
   String[] splits=regEx.split(elementContent);
//System.out.println("# pieces:"+splits.length);
   for (int i=0; i<splits.length; i++) {

//System.out.println("current:"+i+ " value: "+splits[i]);
     splitResults.add(splits[i]);
   }
   return splitResults;
}

public int getType(){
    return SPLIT;
}


}